<template>
	<f7-page name="residentreportdetail" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title v-if="residentreport && residentreport.category" class="show-small-title">Aduan</f7-nav-title>
            <f7-nav-title-large v-if="residentreport && residentreport.category">{{ residentreport.category.name }}</f7-nav-title-large>
            <f7-nav-right v-if="residentreport && residentreport.category">
                <f7-link :href="`/resident-reports/view/${residentreport.id}/comments/`">
                    <f7-icon ios="f7:chat" aurora="f7:chat" md="f7:chat" class="icon f7-icons">
					    <f7-badge color="red">{{ residentreport.total_comment.kformat() }}</f7-badge>					
				    </f7-icon>
                </f7-link>
            </f7-nav-right>
		</f7-navbar>

        <f7-block v-if="residentreport != null">
            <f7-swiper v-if="residentreport.medias.length > 0" pagination :params="{loop: false, speed:900, slidesPerView: 1, spaceBetween: 20}">
                <f7-swiper-slide class="resident-report-has-browser" v-for="item in residentreport.medias" v-bind:key="item.id">
                    <span class="image-thumb" :style="`background-image: url(${item.url.medium});`"></span>
                </f7-swiper-slide>
            </f7-swiper>
            <f7-swiper v-else :params="{loop: false, speed:900, slidesPerView: 1, spaceBetween: 20}">
                <f7-swiper-slide>
                    <span class="image-thumb" :style="`background-image:url(${require('../assets/no-photo.jpg')})`"></span>
                </f7-swiper-slide>
            </f7-swiper>            
        </f7-block>

        <f7-block v-if="residentreport && residentreport.category" class="product-detail">
            <h3 class="no-margin-bottom">{{ residentreport.title }}</h3>
            <small class="display-block margin-small-bottom">Terakhir Diperbaharui: {{ dateFormat(residentreport.updated, 'DD MMMM YYYY') }}</small>
            <span v-html="residentreport.body" class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;">{{ residentreport.body }}</span>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom:1px dashed #ddd;"><f7-icon f7="person" size="18px" color="green"></f7-icon>  {{ residentreport.author.profile.fullname }}</span>

            <f7-list style="border-bottom:1px dashed #ddd;" class="no-margin" no-hairlines v-if="residentreport.latitude != null && residentreport.longitude != null">
                <f7-list-item>
                    <div class="item-title"><f7-icon f7="placemark" size="20px" color="orange"></f7-icon> Lokasi aduan {{ currentLocation != null ? distance(currentLocation.latitude, currentLocation.longitude, residentreport.latitude, residentreport.longitude) : '' }}</div>
                    <f7-toggle 
                        color="blue"
                        value="1"
                        :checked="showMap"
                        @toggleChange="handleShowMap($event)"></f7-toggle>
                </f7-list-item>
            </f7-list>

            <GmapMap 
                id="map"
                v-if="showMap == true" 
                ref="mapRef"
                :options="{
                    zoomControl: true,
                    mapTypeControl: false,
                    scaleControl: false,
                    streetViewControl: false,
                    rotateControl: false,
                    fullscreenControl: true,
                    disableDefaultUi: false,
                    scrollwheel: false
                }"
                :zoom="map.zoom"
                :center="map.center">
                <GmapMarker :position="map.center" :clickable="false" :draggable="false"></GmapMarker>
            </GmapMap>

        </f7-block>        
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, distance } from '../js/utils';
export default {
    name: 'ResidentReportDetail',
    data(){
        return {
            photoBrowser: null,
            showMap: false,
            map: {
				zoom: 14,
				center: {
					lat: -2.9760735,
					lng: 104.77543070000002
				}
			},
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
		...mapGetters('residentreport', [
			'residentreport'
		]),
        currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
    },
    methods: {
        dateFormat,
        distance,
        getResidentReport(){
            const self = this;
            const app = self.$f7;

            app.preloader.show('green');

            self.$store.dispatch('residentreport/viewResidentReport', {
                id: self.$f7route.params.id,
                only: 'id,number,title,body,latitude,longitude,created,updated,category.id,category.name,medias.mimetype,medias.url,medias.filename,medias.original_filename,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media,total_comment'
            }).then(() => {
                app.preloader.hide();
                self.phottoBrowserInit();

                if(self.residentreport.latitude != null && self.residentreport.longitude != null){
                    self.showMap = true;

                    self.map.zoom = 18;
                    self.map.center.lat = self.residentreport.latitude;
                    self.map.center.lng = self.residentreport.longitude;
                }
            });
        },
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            self.getResidentReport();
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('residentreport/resetResidentReport');
            self.photoBrowser.destroy();
        },
        phottoBrowserInit(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            if(self.residentreport.medias != null){
                let medias = self.residentreport.medias.map((x) => x.url.original);
                self.photoBrowser = app.photoBrowser.create({
                    photos: medias,
                    type: 'popup'
                });

                $$(document).on('click', '.resident-report-has-browser', function(){
                    self.photoBrowser.open();
                });
            }
        },
        handleShowMap(value){
			const self = this;
            self.showMap = value;
        },
    }
}
</script>
